;       Russian keyboard driver
;       Cyril Slobin, 1993-2000

;       $ver 4.1

code    segment
        assume  cs:code, ds:code

hello   db      13, 10
        db      'Russian keyboard driver', 13, 10
        db      'Cyril Slobin, 1993-2000', 13, 10
        db      '$ver 4.1', 13, 10

origin: org     53h     ; start of PSP safe region

old_9h  dd      ?
flag    db      0
last1   db      0
last2   db      0
last3   db      0

IFDEF MS

table1  db      0, '1234567890-=', 0
        db      0, '㪥', 0
        db      0, '뢠஫'
        db      0, '\ᬨ.'

table2  db      0, '!";%:?*()_+', 0
        db      0, '', 0
        db      0, ''
        db      0, '/,'

ELSE
IFDEF RAW

table1  db      0, '1234567890-=', 0
        db      0, '㪥', 0
        db      0, '뢠஫'
        db      0, '\ᬨ/'

table2  db      0, '!@#$%^&*()_+', 0
        db      0, '', 0
        db      0, ''
        db      0, '|?'

ELSE

table1  db      0, '1234567890-=', 0
        db      0, '㪥', 0
        db      0, '뢠஫'
        db      0, '\ᬨ/'

table2  db      0, '!"#;:,.*()_+', 0
        db      0, '', 0
        db      0, ''
        db      0, '|?'

ENDIF
ENDIF

new_9h: cli
        push    ax
        push    bx
        push    di
        push    ds
        push    es

        push    cs
        pop     ds

        mov     ax, 0040h
        mov     es, ax
        mov     di, es:[1Ch]

        in      al, 60h
        pushf
        call    old_9h

        mov     ah, byte ptr last1
        mov     bx, word ptr last2
        cmp     ax, 0E09Dh
        jne     nosw
        cmp     bx, 0E01Dh
        jne     nosw
        not     flag
nosw:   mov     word ptr last1, ax
        mov     byte ptr last3, bl

        mov     bx, offset table1 - 1

        mov     ah, es:[17h]
        test    ah, 0Ch
        jnz     done
        test    flag, 1
        jz      done
        cmp     al, 35h
        ja      done

        je      nocaps
        cmp     al, 2Bh
        je      nocaps
        cmp     al, 10h
        jb      nocaps
        test    ah, 40h
        jz      nocaps

        test    ah, 3
        jz      upcase
        jnz     doit

nocaps: test    ah, 3
        jz      doit

upcase: mov     bx, offset table2 - 1
doit:   xor     ah, ah
        xlat
        cmp     al, 0
        je      done
        stosw

done:   pop     es
        pop     ds
        pop     di
        pop     bx
        pop     ax
        iret

main:   push    cs
        pop     ds

        mov     dx, offset hello
        mov     ah, 09h
        int     21h

        mov     si, offset origin
        mov     di, offset origin
        mov     cx, main - origin
        cld
        rep movsb

        push    es
        pop     ds

        mov     ax, 3509h
        int     21h
        mov     word ptr old_9h+0, bx
        mov     word ptr old_9h+2, es

        mov     dx, offset new_9h
        mov     ax, 2509h
        int     21h

        mov     ax, ds:[2Ch]
        mov     es, ax
        mov     ah, 49h
        int     21h

        mov     dx, offset main
        int     27h

code    ends
        end     main
